/*
 * $Id: HTMLDocument.java,v 1.2 2005/09/08 01:32:34 sugimotokenichi Exp $
 * Copyright (C) 2005 SUGIMOTO Ken-ichi
 * 作成日: 2005/07/24
 */
package feat.v1.template;


/**
 * HTML文書の最上位ノード。
 * @author SUGIMOTO Ken-ichi
 */
public interface HTMLDocument extends HTMLNode, CompositeNode {

    /**
     * このドキュメントのエンコーディングを返す。
     * @return
     */
    public String getEncoding();

    /**
     * このノードを先頭とするノードツリーからXPathにマッチするノードを返す。
     * @param xpath String
     * @return
     */
    public HTMLNode find(String xpath) throws NodeNotFoundException;

    /**
     * このノードを先頭とするノードツリーからXPathにマッチするすべてのノードを返す。
     * @param xpath
     * @return XPathにマッチするノードが無かったら空のIteratorを返す。
     */
    public HTMLNodeList select(String xpath);


    public String toHTML();

}